package ice;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import android.widget.MediaController;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnCompletionListener;
import anywheresoftware.b4a.objects.ViewWrapper;

@ActivityObject
@Version(1.01F)
@Author("IceFairy")
@DependsOn(values="vve")
@ShortName("VideoViewExt")
public class vvewrap extends ViewWrapper<videoviewExt> {
	videoviewExt vveExt=null;
	
	 public void Initialize(final BA ba, final String EventName)
	  {
	   vveExt=new videoviewExt(ba.context);
	   super.setObject(vveExt);
	    super.Initialize(ba, EventName);
	    vveExt.setOnCompletionListener(new OnCompletionListener() {
			
			@Override
			public void onCompletion(MediaPlayer mp) {
				// TODO Auto-generated method stub
				ba.raiseEvent(((videoviewExt)getObject()), EventName + "_complete", new Object[0]);
			}
		});
	    
	  }
	 

	  public void LoadVideo(String Dir, String FileName)
	  {
	    if (Dir.equals(anywheresoftware.b4a.objects.streams.File.getDirAssets())) {
	      throw new RuntimeException("Cannot load video from assets folder.");
	    }
	    if (Dir.equals("ContentDir")) {
	      vveExt.setVideoPath(FileName);
	    }
	    else if (Dir.equals("http")) {
	    	vveExt.setVideoPath(FileName);
	    }
	    else
	    	vveExt.setVideoPath(new java.io.File(Dir, FileName).toString());
	  }

	  public void Play()
	  {
		  vveExt.start();
	  }

	  public void Pause()
	  {
		  vveExt.pause();
	  }

	  public void Stop()
	  {
		  vveExt.stopPlayback();
	  }

	  public boolean IsPlaying()
	  {
	    return vveExt.isPlaying();
	  }

	  public int getPosition()
	  {
	    return vveExt.getCurrentPosition();
	  }
	  public void setPosition(int v) {
		  vveExt.seekTo(v);
	  }

	  public int getDuration()
	  {
	    return vveExt.getDuration();
	  }

	  public void setMediaControllerEnabled(boolean v)
	  {
		  vveExt.setMediaController(v ? new MediaController(ba.context) : null);
	  }

	  public String toString() {
	    if (getObjectOrNull() == null)
	      return super.toString();
	    if (!vveExt.isPlaying()) {
	      return "Not playing";
	    }
	    return "Playing, Position=" + getPosition() + ", Duration=" + getDuration();
	  }
	 
		  
	  
}
